import config
from util import *
import sys
from specs import * 
from gen import Player 
from futil import *


def finder():
    print ''
    prgm = get_current_program()
    prgm.pattern_instances['RecogCanCheckSelinux'] = []
    nbr = 0
    for obj in get_prgm_classes():
        sys.stdout.write('.')
        objPlayer = Player(obj, 'obj', 0,RecogCanCheckSelinux, [], {})
        obj_coll_names = ['filesystems']
        filesystems__just = [f for f in obj.in_from() if contains_str(f.name,"/proc/filesystems")]
        if empty(filesystems__just):
            continue
        filesystems__items = next_classes_with_justifications(None,filesystems__just)
        for filesystems in filesystems__items.keys():
            filesystems__evidence = filesystems__items[filesystems]
            filesystemsPlayer = Player(filesystems, 'filesystems', -1,RecogCanCheckSelinux,filesystems__evidence, {})
            filesystems_coll_names = ['current']
            current__just = [f for f in obj.in_from() if contains_str(f.name, "/proc/self/attr/current")]
            if empty(current__just):
                continue
            current__items = next_classes_with_justifications(None,current__just)
            current = current__items.keys()
            current__aggr = make_aggr('current',RecogCanCheckSelinux,current__items)
            dict_put(filesystemsPlayer.with,'current',current__aggr)
            if empty(setdiff(filesystems_coll_names,filesystemsPlayer.with.keys())):
                dict_put(objPlayer.with,'filesystems',filesystemsPlayer)
        #if collaborators, then add to found set
        if empty(setdiff(obj_coll_names, objPlayer.with.keys())):
            nbr = nbr + 1
            objPlayer.nbr = nbr
            prgm.pattern_instances['RecogCanCheckSelinux'].append(objPlayer)
    print nbr
    return prgm.pattern_instances['RecogCanCheckSelinux']
